var Hangman = (function() {
    var Hangman = function(canvas, answer) {
        this.canvas = canvas;
        this.props = {
            answer: answer,
            wrong: 0,
            right: 0,
            check: [],
            guessed: [],
            win: 0,
            gameover: false
        };
        this.ctx;
        this.fn = {
            contains: function(arr, obj) {
                var i = arr.length;
                while (i--) {
                    if (arr[i] === obj) {
                        return true;
                    }
                }
                return false;
            },
            Wrong: function() {
                var me = this;
                var parts = {};
                switch (true) { // thanks Raynos
                case (this.props.wrong > 5):
                    parts.rightLeg = true;
                case (this.props.wrong > 4):
                    parts.leftLeg = true;
                case (this.props.wrong > 3):
                    parts.rightArm = true;
                case (this.props.wrong > 2):
                    parts.leftArm = true;
                case (this.props.wrong > 1):
                    parts.body = true;
                case (this.props.wrong > 0):
                    parts.head = true;
                }
                this.fn.drawStickMan.apply(this, [parts]);
            },
            Right: function() {
                this.fn.drawLetters.apply(this);
            },
            GameOver: function(message) {
                this.ctx.beginPath();
                this.ctx.fillRect(100, 150, 200, 50);
                this.ctx.fillStyle = "#F00";
                this.ctx.fillText(message, 150, 172);
                this.ctx.fillText("Game Over", 150, 192);
                this.ctx.closePath();
                this.ctx.stroke();
                this.props.gameover = true;
            },
            drawBackground: function() {
                this.ctx.lineWidth = "2";

                this.ctx.beginPath();
                this.ctx.moveTo(0, 310);
                this.ctx.lineTo(400, 310);
                this.ctx.closePath();
                this.ctx.stroke();

                this.ctx.lineWidth = "4";

                this.ctx.beginPath();
                this.ctx.moveTo(25, 300);
                this.ctx.lineTo(350, 300);
                this.ctx.lineTo(350, 310);
                this.ctx.moveTo(25, 300);
                this.ctx.lineTo(25, 310);
                this.ctx.closePath();
                this.ctx.stroke();

                this.ctx.beginPath();
                this.ctx.moveTo(25, 300);
                this.ctx.lineTo(25, 25);
                this.ctx.closePath();
                this.ctx.stroke();

                this.ctx.beginPath();
                this.ctx.moveTo(23, 25);
                this.ctx.lineTo(195, 25);
                this.ctx.closePath();
                this.ctx.stroke();

                this.ctx.beginPath();
                this.ctx.moveTo(195, 23);
                this.ctx.lineTo(195, 75);
                this.ctx.closePath();
                this.ctx.stroke();

            },
            drawStickMan: function(parts) {
                if (parts.head) {
                    this.ctx.beginPath();
                    this.ctx.arc(195, 100, 25, 0, Math.PI * 2, true);
                    this.ctx.closePath();
                    this.ctx.stroke();
                }
                if (parts.body) {
                    this.ctx.beginPath();
                    this.ctx.moveTo(195, 125);
                    this.ctx.lineTo(195, 195);
                    this.ctx.closePath();
                    this.ctx.stroke();
                }
                if (parts.leftArm) {
                    this.ctx.beginPath();
                    this.ctx.moveTo(195, 135);
                    this.ctx.lineTo(185, 180);
                    this.ctx.closePath();
                    this.ctx.stroke();
                }
                if (parts.rightArm) {
                    this.ctx.beginPath();
                    this.ctx.moveTo(195, 135);
                    this.ctx.lineTo(205, 180);
                    this.ctx.closePath();
                    this.ctx.stroke();
                }
                if (parts.leftLeg) {
                    this.ctx.beginPath();
                    this.ctx.moveTo(195, 195);
                    this.ctx.lineTo(185, 250);
                    this.ctx.closePath();
                    this.ctx.stroke();
                }
                if (parts.rightLeg) {
                    this.ctx.beginPath();
                    this.ctx.moveTo(195, 195);
                    this.ctx.lineTo(205, 250);
                    this.ctx.closePath();
                    this.ctx.stroke();
                }
            },
            drawLetters: function() {
                var words = this.props.answer.split(" ");
                var limit = 370;
                var wAt = 0;
                var y = 340;
                var x = 15;
                for (var i = 0, l = words.length; i < l; i++) {
                    wAt = (wAt + words[i].length * 20 + 35);
                    if (wAt >= limit) {
                        wAt = words[i].length * 20;
                        y = y + 30;
                        x = 15;
                    }
                    var letters = words[i].split("");
                    for (var j = 0, jl = letters.length; j < jl; j++) {
                        this.ctx.beginPath();
                        this.ctx.moveTo(x, y);
                        this.ctx.lineTo(x + 20, y);
                        for (var k = 0, kl = this.props.check.length; k < kl; k++) {
                            if (this.props.check[k].toLowerCase() == letters[j].toLowerCase()) {
                                this.ctx.fillText(letters[j], x + 4, (y - 6));
                            }
                        }
                        this.ctx.closePath();
                        this.ctx.stroke();
                        x = x + 25;
                    }
                    x = x + 25;
                }

            },
            init: function() {
                if (this.canvas.getContext) {
                    this.props.win = this.props.answer.replace(/ /g, "").length;
                    this.canvas.setAttribute("height", 460);
                    this.canvas.setAttribute("width", 400);
                    this.ctx = this.canvas.getContext('2d');
                    this.ctx.font = "18px monospace";
                    this.fn.drawBackground.apply(this);
                    this.fn.drawLetters.apply(this);
                }
            }
        };
        this.fn.init.apply(this);
    };
    Hangman.prototype.submit = function(input) {
        if (!(this.fn.contains.apply(this, [this.props.guessed, input])) && !(this.props.gameover)) {
            this.props.guessed.push(input);
            var count = this.props.answer.replace(new RegExp("[^" + input + "]", "gi"), "").length;
            if (count == 0) {
                this.props.wrong++;
                this.fn.Wrong.apply(this);
            } else {
                this.props.check.push(input);
                this.props.right = (this.props.right + count);
                this.fn.Right.apply(this);
            }

            if (this.props.wrong == 6) {
                this.fn.GameOver.apply(this, ["You Loose!"]);
            }
            if (this.props.right == this.props.win) {
                this.fn.GameOver.apply(this, ["Winner!"]);
            }
            return count;
        }
        return false;
    };
    return Hangman;
})();